Loading...
Searching...
No Matches
BALL::Selectable Class Reference
Foundation Classes » Concepts » Miscellaneous

`#include <BALL/CONCEPT/selectable.h>`

Inheritance diagram for BALL::Selectable:

## Public Member Functions

Constructors and Destructors
| Selectable ()
| Selectable (const Selectable &selectable, bool deep=true)
virtual | ~Selectable ()
virtual void | clear ()
Assignment
void | set (const Selectable &selectable, bool deep=true)
const Selectable & | operator= (const Selectable &selectable)
void | get (Selectable &selectable, bool deep=true) const
void | swap (Selectable &selectable)
virtual void | select ()
virtual void | deselect ()
virtual void | setSelected (bool selected)
Predicates
bool | isSelected () const
bool | operator== (const Selectable &selectable) const
bool | operator!= (const Selectable &selectable) const
Storable interface.
void | write (PersistenceManager &pm) const
bool | read (PersistenceManager &pm)

## Debugging and Diagnostics

bool | selected_
virtual void | dump (::std::ostream &s=std::cout, Size depth=0) const

## Detailed Description

Selectable Concept. Selectable implements the ability of objects to be selected. It is used in the BALL kernel to mark parts of the kernel objects for special operations. In principle, Selectable provides a boolean flag and defines an interface to access this flag.

Interface: Storable

Definition at line 36 of file selectable.h.

## Constructor & Destructor Documentation

## Selectable() [1/2]

BALL::Selectable::Selectable | ( |  | ) |

Default Constructor. Creates a new selectable object and sets its state to unselected.

## Selectable() [2/2]

BALL::Selectable::Selectable | ( | const Selectable & | selectable,
|  | bool | deep = true )

Copy constructor. Creates a copy of selectable object.

Parameters

  selectable | the Selectable object to be copied
  deep | ignored

## ~Selectable()

virtual BALL::Selectable::~Selectable | ( |  | ) |

virtual

Destructor. The destructor has no functionality.

## Member Function Documentation

## clear()

virtual void BALL::Selectable::clear | ( |  | ) |

virtual

Clear the selection flag. Clear resets the selection flag to unselected.

Reimplemented in BALL::Atom, BALL::AtomContainer, BALL::Bond, BALL::Composite, BALL::NucleicAcid, BALL::Nucleotide, BALL::PDBAtom, BALL::Protein, BALL::Residue, and BALL::SecondaryStructure.

## deselect()

virtual void BALL::Selectable::deselect | ( |  | ) |

virtual

Deselect the object. The internal flag is set to false.

Reimplemented in BALL::Composite.

## dump()

virtual void BALL::Selectable::dump | ( | ::std::ostream & | s = std::cout,
|  | Size | depth = 0 ) const

virtual

## get()

void BALL::Selectable::get | ( | Selectable & | selectable,
|  | bool | deep = true ) const

Copy the contents of this object into another.

Parameters

  selectable | the object to be assigned to
  deep | ignored

## isSelected()

bool BALL::Selectable::isSelected | ( |  | ) | const

Get the object state.

Returns
  bool true, if the object is selected, false otherwise

## operator!=()

bool BALL::Selectable::operator!= | ( | const Selectable & | selectable | ) | const

Inequality operator

## operator=()

const Selectable & BALL::Selectable::operator= | ( | const Selectable & | selectable | ) |

Assignment operator. Assigns the contents of another Selectable object to this object.

Parameters

  selectable | the object to be copied

## operator==()

bool BALL::Selectable::operator== | ( | const Selectable & | selectable | ) | const

Equality operator

## read()

bool BALL::Selectable::read | ( | PersistenceManager & | pm | ) |

Persistent stream reading. This method reads a boolean variable from the persistent stream using the readPrimitive method of the PersistenceManager.

Parameters

  pm | the persistence manager

## select()

virtual void BALL::Selectable::select | ( |  | ) |

virtual

Accessors Select the object. The internal flag is set to true.

Reimplemented in BALL::Composite.

## set()

void BALL::Selectable::set | ( | const Selectable & | selectable,
|  | bool | deep = true )

Assign the contents of another selectable object to this object.

Parameters

  selectable | the object whose contents are to be copied
  deep | ignored

## setSelected()

virtual void BALL::Selectable::setSelected | ( | bool | selected | ) |

inline virtual

For faster access

Definition at line 123 of file selectable.h.

## swap()

void BALL::Selectable::swap | ( | Selectable & | selectable | ) |

Swap the contents of two objects.

Parameters

  selectable | the object to swap contents with

## write()

void BALL::Selectable::write | ( | PersistenceManager & | pm | ) | const

Persistent stream writing. This method writes a boolean variable to the persistent stream using the writePrimitive method of the PersistenceManager.

Parameters

  pm | the persistence manager

## Member Data Documentation

## selected_

bool BALL::Selectable::selected_

protected

Definition at line 184 of file selectable.h.